part of katana_routing;

/// Create a variable container.
@immutable
class VariableContainer {
  late final WidgetRef _ref;

  /// When executed, [Scoped], [ScopedWidget] and [PageScopedWidget] will be rebuilt.
  ///
  /// [callback] is called before the rebuild is done.
  @protected
  @mustCallSuper
  void setState(VoidCallback callback) {
    callback.call();
    _ref.rebuild();
  }

  /// Called when the container is created.
  @mustCallSuper
  void initState() {}

  /// Called when the page is Disposed.
  @mustCallSuper
  void dispose() {}
}
